//audio
datablock AudioProfile(FaecPwnerReloadSound)
{
   filename    = "./FaecPwnerReload.wav";
   description = AudioClose3d;
   preload = true;
};


//emitter
datablock ParticleData(FaecPwnerSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.5";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(FaecPwnerSmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FaecPwnerSmokeParticle";
};

datablock ParticleData(FaecPwnerExplosionParticle)
{
	dragCoefficient      = 0.2;
	gravityCoefficient   = -0.4;
	inheritedVelFactor   = 0.6;
	constantAcceleration = 0.0;
	lifetimeMS           = 1500;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 12;
	spinRandomMin		= -25;
	spinRandomMax		= 25;
	colors[0]     = "0.6 0.6 0.2 0.3";
	colors[1]     = "0.9 0.9 0.2 0.55";
	colors[2]     = "0.9 0.9 0.7 0.0";
	sizes[0]      = 2.0;
	sizes[1]      = 6.0;
	sizes[2]      = 8.0;
	times[0]	= 0;
	times[1]	= 0.2;
	times[2]	= 1;

	useInvAlpha = true;
};
datablock ParticleEmitterData(FaecPwnerExplosionEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0.4;
   velocityVariance = 0.2;
   ejectionOffset   = 0.3;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FaecPwnerExplosionParticle";

   uiName = "FaecPwner Explosion Smoke";
};

datablock ParticleData(FaecPwnerExplosionFlashParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.4;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 60;
	lifetimeVarianceMS   = 45;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 0.0 0.6";
	colors[1]     = "0.9 0.6 0.0 0.0";
	sizes[0]      = 7;
	sizes[1]      = 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(FaecPwnerExplosionFlashEmitter)
{
	lifeTimeMS = 95;

   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "faecPwnerExplosionFlashParticle";

   useEmitterColors = true;
   uiName = "FaecPwner Explosion Flash";
};

datablock ParticleData(FaecPwnerDebrisTrailParticle)
{
	dragCoefficient      = 0.4;
	gravityCoefficient   = -0.15;
	inheritedVelFactor   = 0.1;
	constantAcceleration = 0.0;
	lifetimeMS           = 900;
	lifetimeVarianceMS   = 70;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 12;
	spinRandomMin		= -25;
	spinRandomMax		= 25;
	colors[0]     = "0.7 0.1 0.0 0.6";
	colors[1]     = "0.8 0.8 0.2 0.7";
	colors[2]     = "0.1 0.1 0.1 0.9";
	colors[3]     = "0.4 0.4 0.4 0.0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.4;
	sizes[2]      = 0.4;
	sizes[3]      = 0.5;
	times[0]	= 0;
	times[1]	= 0.2;
	times[2]	= 0.3;
	times[3]	= 1;

	useInvAlpha = true;
};
datablock ParticleEmitterData(FaecPwnerDebrisTrailEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FaecPwnerDebrisTrailParticle";
};

datablock DebrisData(FaecPwnerDebris)
{
   emitters = "FaecPwnerDebrisTrailEmitter";

	shapeFile = "base/data/shapes/empty.dts";
	lifetime = 0.4;
	minSpinSpeed = 0;
	maxSpinSpeed = 0;
	elasticity = 0.7;
	friction = 0.4;
	numBounces = 0;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = false;

	gravModifier = 4;
};

datablock ExplosionData(FaecPwnerExplosion)
{
	soundProfile = VehicleExplosionSound;

   lifeTimeMS = 150;

   particleEmitter = FaecPwnerExplosionEmitter;
   particleDensity = 6;
   particleRadius = 0.2;

   emitter[0] = FaecPwnerExplosionFlashEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   debris = FaecPwnerDebris;
   debrisNum = 6;
   debrisNumVariance = 3;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 180;
   debrisVelocity = 30;
   debrisVelocityVariance = 15;

   shakeCamera = false;
   camShakeFreq = "5.0 6.0 5.0";
   camShakeAmp = "2.0 7.0 2.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 2;
   lightEndRadius = 10;
   lightStartColor = "1 1 0 1";
   lightEndColor = "0 0 0 0";

   damageRadius = 9;
   radiusDamage = 70;

   impulseRadius = 5;
   impulseForce = 6;
   
};

AddDamageType("FaecPwner",   '<bitmap:add-ons/Weapon_FaecPwner/CI_FaecPwner> %1',    '%2 <bitmap:add-ons/Weapon_FaecPwner/CI_FaecPwner> %1',0.5,1);
datablock ProjectileData(FaecPwnerProjectile)
{
   projectileShapeName = "./LightBall.dts";
   directDamage        = 0;
   directDamageType    = $DamageType::FaecPwner;
   radiusDamageType    = $DamageType::FaecPwner;

   brickExplosionRadius = 0.95;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 8;
   brickExplosionMaxVolume = 6;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 10;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse     = 0;
   explosion           = FaecPwnerExplosion;

   muzzleVelocity      = 60;
   velInheritFactor    = 1;

   armingDelay         = 1500;
   lifetime            = 900;
   fadeDelay           = 900;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.45;
   isBallistic         = true;
   gravityMod = 1.0;
   explodeondeath = true;

   hasLight    = true;
   lightRadius = 4.0;
   lightColor  = "1 1 0";
   uiName = "FaecPwner Ball";
};

//////////
// item //
//////////
datablock ItemData(FaecPwnerItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./FaecPwner.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "FaecPwner";
	iconName = "./Icon_FaecPwner";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = FaecPwnerImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(FaecPwnerImage)
{
   // Basic Item properties
   shapeFile = "./FaecPwner.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = FaecPwnerItem;
   ammo = " ";
   projectile = FaecPwnerProjectile;
   projectileType = Projectile;

   //casing = FaecPwnerShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 3000;

   doColorShift = true;
   colorShiftColor = FaecPwnerItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.15;
	stateTransitionOnTimeout[0]     = "Ready";
	stateSound[0]			  = weaponSwitchSound;

	stateName[1]                    = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;
	stateTimeoutValue[1]		  = 0.01;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.14;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]		  = true;
	stateEmitter[2]			  = gunFlashEmitter;
	stateEmitterTime[2]		  = 0.05;
	stateEmitterNode[2]		  = "muzzleNode";
	stateSound[2]			  = gunShot1Sound;

	stateName[3] 			  = "Smoke";
	stateEmitter[3]			  = FaecPwnerSmokeEmitter;
	stateEmitterTime[3]		  = 0.1;
	stateEmitterNode[3]		  = "muzzleNode";
	stateTimeoutValue[3]            = 0.5;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			  = "Reload";
	stateTimeoutValue[4]		  = 3;
	stateSequence[4]			  = "reload";
	stateTransitionOnTimeout[4]	  = "Wait";
	stateWaitForTimeout[4]		  = true;
	stateEjectShell[4]       	  = true;
	stateSound[4]			  = FaecPwnerReloadSound;
	
	stateName[5]			  = "Wait";
	stateTimeoutValue[5]		  = 0.1;
	stateTransitionOnTimeout[5]	  = "Ready";
};

function FaecPwnerImage::onFire(%this,%obj,%slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();
      

	%projectile = %this.projectile;
	%spread = 0.0015;
	%shellcount = 5;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}